package com.lantone.qc.kernel;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONException;
import com.alibaba.fastjson.JSONObject;
import com.lantone.qc.pub.util.PropertiesUtil;

import java.sql.*;
import java.util.*;

/**
 * @ClassName : DataTest
 * @Description :
 * @Author : 楼辉荣
 * @Date: 2020-04-01 20:06
 */
public class DataTest {
    public static void main(String[] args ) {

    }

    public static List<Map<String, String>> loadHomePage(String tableName, String patientId) {
        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        List<Map<String, String>> resultList = null;
        try {
            PropertiesUtil propertiesUtil = new PropertiesUtil("kernel.properties");
            Class.forName(propertiesUtil.getProperty("oracle.test.driver"));

            Properties props = new Properties();
            String url = propertiesUtil.getProperty("oracle.test.url");
            // 127.0.0.1是本机地址，1521是Oracle默认连接端口，DATABASE_NAME为实例名（SID）
            String user = propertiesUtil.getProperty("oracle.test.user");// 用户系统默认的账户名
            String password = propertiesUtil.getProperty("oracle.test.password");// 你安装时选设置的密码
            props.put("user", user);
            props.put("password", password);
            props.put("defaultRowPrefetch", "15");
            props.put("remarksReporting", "true");
            //默认情况下不允许用dba身份连接数据库，通过property设置以实现dba连接
            conn = DriverManager.getConnection(url, props);
            System.out.println("connection succeed!");
            stmt = conn.createStatement();

            DatabaseMetaData dmd = conn.getMetaData();
            ResultSet dmdRs = dmd.getColumns(null, null, tableName, null);

            Map<String, String> colMap = new LinkedHashMap<>();
            while(dmdRs.next()){
                colMap.put(dmdRs.getString(4), dmdRs.getString("REMARKS"));
            }
            dmdRs.close();

            rs = stmt.executeQuery("select * from " + tableName + " where brzyid = '" + patientId + "'");
            resultList = resultSetToJson(rs, colMap);
        } catch (SQLException ex) {
            ex.printStackTrace();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                if (rs != null) {
                    rs.close();
                    rs = null;
                }
                if (stmt != null) {
                    stmt.close();
                    stmt = null;
                }
                if (conn != null) {
                    conn.close();
                    conn = null;
                }
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
        return resultList;
    }

    public static List<Map<String, String>> resultSetToJson(ResultSet rs, Map<String, String> map) throws SQLException, JSONException {
        // 获取列数
        ResultSetMetaData metaData = (ResultSetMetaData) rs.getMetaData();
        int columnCount = metaData.getColumnCount();
        List<Map<String, String>> resultList = new ArrayList<>();
        while (rs.next()) {
            // 遍历ResultSet中的每条数据
            Map<String, String> result = new LinkedHashMap<>();
            // 遍历每一列
            for (int i = 1; i <= columnCount; i++) {
                String columnName = metaData.getColumnLabel(i);
                String value = rs.getString(columnName) == null ? "" : rs.getString(columnName);
                result.put(map.get(columnName), value);
            }
            resultList.add(result);
        }
        return resultList;
    }

}